﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using HeuristicLab.Common;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  [Serializable]
  public class Job : LightweightJob {
    [DataMember]
    public Guid UserId { get; set; }
    [DataMember]
    public int Priority { get; set; }
    [DataMember]
    public int CoresNeeded { get; set; }
    [DataMember]
    public int MemoryNeeded { get; set; }
    [DataMember]
    public Guid? ProjectId { get; set; }

    public override string ToString() {
      return base.ToString() + "State: " + JobState + ", [SlaveId : " + SlaveId + " ] , DateCreated: " + DateCreated + ", DateCalculated: " + DateCalculated +
        "Priority: " + Priority + ", CoresNeeded: " + CoresNeeded;
    }

    public Job() {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      var clone = (Job)base.Clone(cloner);
      clone.UserId = this.UserId;
      clone.Priority = this.Priority;
      clone.CoresNeeded = this.CoresNeeded;
      clone.MemoryNeeded = this.MemoryNeeded;
      clone.ProjectId = this.ProjectId;
      return clone;
    }
  }
}
